unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Psock, StdCtrls, ComCtrls, Menus, Buttons;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Memo1: TMemo;
    s: TPowersock;
    StatusBar1: TStatusBar;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    PopupMenu1: TPopupMenu;
    N121: TMenuItem;
    N131: TMenuItem;
    N141: TMenuItem;
    ListBox1: TListBox;
    PopupMenu2: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Edit6: TEdit;
    Label3: TLabel;
    SpeedButton3: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure sConnect(Sender: TObject);
    procedure sConnectionFailed(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure N121Click(Sender: TObject);
    procedure N131Click(Sender: TObject);
    procedure N141Click(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit6Change(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure NextIP;
    { Public declarations }
  end;

var
  Form1: TForm1;
  It,lastIP:integer;
  go:boolean;
implementation

uses Unit3;

{$R *.DFM}
procedure TForm1.NextIP;
begin
  s.disconnect;
  if it=listbox1.Items.Count then
  begin
    inc(lastIP);
    s.Host := edit1.text +'.'+
    edit2.text + '.'+
    edit3.text + '.'+
    inttostr(lastIP);
    It:=1;
    s.port:=strtoint(listbox1.items.Strings[it-1]);
  end else
  begin
    inc(It);
    s.port:=strtoint(listbox1.items.Strings[it-1]);
  end;
  statusbar1.SimpleText := 'Scanning '+s.Host+' : '+inttostr(s.port);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit1.Enabled := false;
  Edit2.Enabled := false;
  Edit3.Enabled := false;
  Edit4.Enabled := false;
  Edit5.Enabled := false;
  speedbutton1.Enabled := false;
  speedbutton2.Enabled := true;
  listbox1.Enabled := false;

  Memo1.lines.add('Scan begin');
  go:=true;
  it:=0;
  lastIP:=strtoint(edit4.text);
  NextIP;
  s.Connect;

  Memo1.lines.add('Scan complete');
  Edit1.Enabled := true;
  Edit2.Enabled := true;
  Edit3.Enabled := true;
  Edit4.Enabled := true;
  Edit5.Enabled := true;
  speedbutton2.Enabled := false;
  speedbutton1.Enabled := true;
  listbox1.Enabled := true;
  s.Disconnect;
end;

procedure TForm1.sConnect(Sender: TObject);
begin
  if not go then
  begin
    s.Disconnect;
    exit;
  end;
  memo1.lines.add('Connect on '+s.host+' : '+inttostr(s.port));
  NextIP;
  if lastIP>strtoint(edit5.text) then
  begin
    memo1.Lines.Add('Scan complete');
    statusbar1.Simpletext := '';
    go:=false;
    Edit1.Enabled := true;
    Edit2.Enabled := true;
    Edit3.Enabled := true;
    Edit4.Enabled := true;
    Edit5.Enabled := true;
    speedbutton1.Enabled := true;
    speedbutton2.Enabled := false;
    listbox1.Enabled := true;
    exit;
  end;
  if go then s.connect else exit;
end;

procedure TForm1.sConnectionFailed(Sender: TObject);
begin
  if not go then
  begin
    s.disconnect;
    exit;
  end;
  NextIP;
  if lastIP>strtoint(edit5.text) then
  begin
    memo1.Lines.Add('Scan complete');
    statusbar1.Simpletext := '';
    go:=false;
    Edit1.Enabled := true;
    Edit2.Enabled := true;
    Edit3.Enabled := true;
    Edit4.Enabled := true;
    Edit5.Enabled := true;
    speedbutton1.Enabled := true;
    speedbutton2.Enabled := false;
    listbox1.Enabled := true;
    exit;
  end;
  if go then s.connect else exit;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  go:=false;
  memo1.Lines.Add('Scan aborted');
  statusbar1.Simpletext := '';
  s.cancel;

  Edit1.Enabled := true;
  Edit2.Enabled := true;
  Edit3.Enabled := true;
  Edit4.Enabled := true;
  Edit5.Enabled := true;
  speedbutton1.Enabled := true;
  speedbutton2.Enabled := false;
  listbox1.Enabled := true;
end;

procedure TForm1.N121Click(Sender: TObject);
begin
  memo1.CopyToClipboard;
end;

procedure TForm1.N131Click(Sender: TObject);
begin
  memo1.Clear;
end;

procedure TForm1.N141Click(Sender: TObject);
begin
  showmessage('YEAH! Bill gates is suxx! Mrakosoft is kal!');
end;

procedure TForm1.Add1Click(Sender: TObject);
begin
  listbox1.Items.Add(inputbox('Add port...','Port:',''));
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
  listbox1.Items.Delete(listbox1.itemindex);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  listbox1.Items.LoadFromFile('ports.txt');
  memo1.clear;
  memo1.lines.add('Host scanner by Mixan');
  memo1.lines.add('');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  listbox1.Items.SaveToFile('ports.txt');
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
  if edit6.text='' then s.TimeOut:=0;
  if edit6.text='' then exit;
  s.TimeOut := strtoint(edit6.text);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  form3.show;
end;

end.
